summaryrefslogtreecommitdiffstats
path: root/scripts/envsetup.sh
diff options
context:
space:
mode:
authorStephane Desneux <stephane.desneux@iot.bzh>2016-06-28 21:27:38 +0000
committerJan-Simon Moeller <jsmoeller@linuxfoundation.org>2016-07-05 18:49:46 +0000
commit24c89f22961bab9a995ab9c18881a3109a1c8109 (patch)
tree1e08f2a594f220c3c38bea49558eb25ab69aca48 /scripts/envsetup.sh
parent641df47d096fb559d6f4f444670205e4510d6791 (diff)
new configuration templates based on fragments
This is the application of the process proposed here: https://lists.linuxfoundation.org/pipermail/automotive-discussions/2016-June/002232.html Bug-AGL: SPEC-180 Change-Id: I5a7015fa810547a9ecf4fb096367323af3cdc670 Signed-off-by: Stephane Desneux <stephane.desneux@iot.bzh>
Diffstat (limited to 'scripts/envsetup.sh')
-rw-r--r--scripts/envsetup.sh279
1 files changed, 77 insertions, 202 deletions
diff --git a/scripts/envsetup.sh b/scripts/envsetup.sh
index 6be4d38e1..27b1de19a 100644
--- a/scripts/envsetup.sh
+++ b/scripts/envsetup.sh
@@ -1,208 +1,83 @@
#!/bin/bash
-find_and_ack_eula() {
- # Handle EULA , if needed. This is a generic method to handle BSPs
- # that might (or not) come with a EULA. If a machine has a EULA, we
- # assume that its corresponding layers has conf/EULA/$MACHINE file
- # with the EULA text, which we will display to the user and request
- # for acceptance. If accepted, the variable ACCEPT_EULA_$MACHINE is
- # set to 1 in local.conf, which can later be used by the BSP.
- # If the env variable EULA_$MACHINE is set it is used by default,
- # without prompting the user.
- # FIXME: there is a potential issue if the same $MACHINE is set in more than one layer.. but we should assert that earlier
- EULA=$(find $1 -print | grep "conf/eula/$MACHINE" | grep -v scripts | grep -v openembedded-core || true)
- if [ -n "$EULA" ]; then
- # remove '-' since we are constructing a bash variable name here
- EULA_MACHINE="EULA_$(echo $MACHINE | sed 's/-//g')"
- # NOTE: indirect reference / dynamic variable
- if [ -n "${!EULA_MACHINE}" ]; then
- # the EULA_$MACHINE variable is set in the environment, so we just configure
- # ACCEPT_EULA_$MACHINE in local.conf
- EULA_ACCEPT=${!EULA_MACHINE}
- else
- # so we need to ask user if he/she accepts the EULA:
- cat <<EOF
-The BSP for $MACHINE depends on packages and firmware which are covered by an
-End User License Agreement (EULA). To have the right to use these binaries
-in your images, you need to read and accept the following...
-
-The firmware package can contains several types
-of firmware (depending on BSP):
-
-* bootloaders: the first stage bootloaders are proprietary for this
- board, they are included in this firmware package.
-* firmware for the power management 'companion' core: on QCOM SoC some
- power management features are implemented in a companion core , called
- RPM, and not on the main CPU.
-* firmware for GPU, WLAN, DSP/GPS and video codecs. These firmware are
- used by their respective linux drivers (DRM, wlan, v4l2, .. ) and are
- loaded on-demand by the main CPU onto the various cores on the SoC.
-EOF
-
- echo
- REPLY=
- while [ -z "$REPLY" ]; do
- echo -n "Do you read the EULA ? (y/n) "
- read REPLY
- case "$REPLY" in
- y|Y)
- READ_EULA=1
- ;;
- n|N)
- READ_EULA=0
- ;;
- *)
- REPLY=
- ;;
- esac
- done
-
- if [ "$READ_EULA" == 1 ]; then
- more -d ${EULA}
- echo
- REPLY=
- while [ -z "$REPLY" ]; do
- echo -n "Do you accept the EULA you just read? (y/n) "
- read REPLY
- case "$REPLY" in
- y|Y)
- echo "EULA has been accepted."
- EULA_ACCEPT=1
- ;;
- n|N)
- echo "EULA has not been accepted."
- ;;
- *)
- REPLY=
- ;;
- esac
- done
- fi
- fi
- fi
-}
-
-if [ -z $1 ]; then
- echo -e "Usage: source envsetup.sh <board/device> [build dir]"
- return 1
-fi
-
-MACHINE="$1"
-echo "MACHINE=$MACHINE"
-
-EULA_ACCEPT=0
-
-case "$MACHINE" in
- "porter")
- # setup proprietary gfx drivers and multimedia packages
- COPY_MM_SCRIPT=meta-renesas/meta-rcar-gen2/scripts/setup_mm_packages.sh
- if [ -f $COPY_MM_SCRIPT ]; then
- . $COPY_MM_SCRIPT
- copy_mm_packages $1
- if [ $? -ne 0 ]; then
- echo "Copying gfx drivers and multimedia packages for '$1' failed."
- return 1
- fi
- fi
-
- if [ ! -d "$TEMPLATECONF" ]; then
- # set template conf for R-Car2 M2 Porter board
- TEMPLATECONF="$PWD/meta-renesas/meta-rcar-gen2/conf"
- fi
- ;;
- "porter-nogfx")
- MACHINE="porter"
- if [ ! -d "$TEMPLATECONF" ]; then
- # set template conf for R-Car2 M2 Porter board
- TEMPLATECONF="$PWD/meta-renesas/meta-rcar-gen2/conf"
- fi
- ;;
- "raspberrypi3")
- ;;
- "raspberrypi2")
- ;;
- "intel-corei7-64")
- ;;
- "minnowboard")
- # alias for minnowboardmax
- MACHINE="intel-corei7-64"
- ;;
- "qemux86")
- ;;
- "qemux86-64")
- ;;
- "dra7xx-evm")
- ;;
- "vayu")
- # nickname for dra7xx-evm
- MACHINE="dra7xx-evm"
- ;;
- "wandboard")
- ;;
- "dragonboard-410c")
- find_and_ack_eula meta-qcom
- ;;
- *)
- # nothing to do here
- echo "WARN: '$MACHINE' is not tested by AGL Distro"
- ;;
-esac
-
-echo "TEMPALTECONF=$TEMPLATECONF"
-# set template conf for each <board/device>
-if [ -z "$TEMPLATECONF" ]; then
- # lookup meta-agl-demo first
- if [ -d "$PWD/meta-agl-demo/templates/$MACHINE/conf" ]; then
- TEMPLATECONF="$PWD/meta-agl-demo/templates/$MACHINE/conf"
- # lookup meta-agl 2nd
- elif [ -d "$PWD/meta-agl/templates/$MACHINE/conf" ]; then
- TEMPLATECONF="$PWD/meta-agl/templates/$MACHINE/conf"
- fi
-fi
-echo "TEMPLATECONF=$TEMPLATECONF"
-
-echo "envsetup: Set '$1' as MACHINE."
-export MACHINE
-
-# fallback
-if [ ! -d "$TEMPLATECONF" ]; then
- # Allow to use templates at meta-agl-demo/conf
- TEMPLATECONF="$PWD/meta-agl-demo/conf"
+################################################################################
+#
+# The MIT License (MIT)
+#
+# Copyright (c) 2016 Stéphane Desneux <sdx@iot.bzh>
+#
+# Permission is hereby granted, free of charge, to any person obtaining a copy
+# of this software and associated documentation files (the "Software"), to deal
+# in the Software without restriction, including without limitation the rights
+# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+# copies of the Software, and to permit persons to whom the Software is
+# furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included in
+# all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+# SOFTWARE.
+#
+################################################################################
+
+#################################################################################
+# IMPORTANT NOTICE
+#
+# This script is a compatiblity script with previous (AGL 1.0) envsetup script
+# It has been replaced by another script named "aglsetup.sh".
+#
+################################################################################
+
+# detect if this script is sourced: see http://stackoverflow.com/a/38128348/6255594
+SOURCED=0
+if [ -n "$ZSH_EVAL_CONTEXT" ]; then
+ [[ $ZSH_EVAL_CONTEXT =~ :file$ ]] && { SOURCED=1; SOURCEDIR=$(cd $(dirname -- $0) && pwd -P); }
+elif [ -n "$KSH_VERSION" ]; then
+ [[ "$(cd $(dirname -- $0) && pwd -P)/$(basename -- $0)" != "$(cd $(dirname -- ${.sh.file}) && pwd -P)/$(basename -- ${.sh.file})" ]] && { SOURCED=1; SOURCEDIR=$(cd $(dirname -- ${.sh.file}) && pwd -P); }
+elif [ -n "$BASH_VERSION" ]; then
+ [[ $0 != "$BASH_SOURCE" ]] && { SOURCED=1; SOURCEDIR=$(cd $(dirname -- $BASH_SOURCE) && pwd -P); }
fi
-echo "envsetup: Using templates for local.conf & bblayers.conf from :"
-echo " '$TEMPLATECONF'"
-export TEMPLATECONF
-
-if [ -n "$2" ]; then
- BUILD_DIR="$2"
+if [ $SOURCED -ne 1 ]; then
+ unset SOURCED
+ unset SOURCEDIR
+ echo "Error: this script needs to be sourced in a supported shell" >&2
+ echo "Please check that the current shell is bash, zsh or ksh and run this script as '. $0 <args>'" >&2
+ return 1
else
- BUILD_DIR=build
-fi
-
-echo "envsetup: Setup build environment for poky/oe."
-echo -e
-
-source poky/oe-init-build-env $BUILD_DIR
-
-if [ -n "$DL_DIR" ]; then
- BB_ENV_EXTRAWHITE="$BB_ENV_EXTRAWHITE DL_DIR"
-fi
-
-if [ -n "$SSTATE_DIR" ]; then
- BB_ENV_EXTRAWHITE="$BB_ENV_EXTRAWHITE SSTATE_DIR"
+ unset SOURCED
+ if [ -z $1 ]; then
+ echo -e "Usage: source envsetup.sh <board/device> [build dir]"
+ return 1
+ fi
+ if [ -n "$2" ]; then
+ BUILD_DIR="$2"
+ else
+ BUILD_DIR=build
+ fi
+ # echo "DEPRECATED..." | figlet -f big -w 80 -c
+ cat <<'EOF' >&2
+ ------------------------------------------------------------------------------
+| using this script is... |
+| _____ ______ _____ _____ ______ _____ _______ ______ _____ |
+| | __ \| ____| __ \| __ \| ____/ ____| /\|__ __| ____| __ \ |
+| | | | | |__ | |__) | |__) | |__ | | / \ | | | |__ | | | | |
+| | | | | __| | ___/| _ /| __|| | / /\ \ | | | __| | | | | |
+| | |__| | |____| | | | \ \| |___| |____ / ____ \| | | |____| |__| | _ _ |
+| |_____/|______|_| |_| \_\______\_____/_/ \_\_| |______|_____(_|_|_) |
+| |
+| To support the newest/upcoming features, please use the script aglsetup.sh. |
+ ------------------------------------------------------------------------------
+EOF
+ . $SOURCEDIR/aglsetup.sh -m $1 -b $BUILD_DIR agl-devel agl-netboot agl-appfw-smack agl-demo
+ rc=$?
+ unset SOURCEDIR
+ unset BUILD_DIR
+ return $rc
fi
-
-export BB_ENV_EXTRAWHITE
-
-unset TEMPLATECONF
-
-case "$EULA_ACCEPT" in
- 1)
- echo "" >> conf/local.conf
- echo "# EULA" >> conf/local.conf
- echo "ACCEPT_EULA_$MACHINE = \"1\"" >> conf/local.conf
- ;;
- *)
- ;;
-esac